(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('controls-context-menu', ['exports', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory(global['controls-context-menu'] = {}, global.ng.core, global.rxjs, global.ng.common));
}(this, (function (exports, core, rxjs, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/services.ts/item.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ItemService = /** @class */ (function () {
        function ItemService() {
            this.hasSubmenuSubject = new rxjs.BehaviorSubject(false);
            this.hasSubmenu$ = this.hasSubmenuSubject.asObservable();
            this.hasWidthSubject = new rxjs.BehaviorSubject(0);
            this.width$ = this.hasWidthSubject.asObservable();
        }
        /**
         * @param {?} hasWidth
         * @return {?}
         */
        ItemService.prototype.setItemWidth = /**
         * @param {?} hasWidth
         * @return {?}
         */
        function (hasWidth) {
            this.hasWidthSubject.next(hasWidth);
        };
        /**
         * @param {?} hasSubmenu
         * @return {?}
         */
        ItemService.prototype.setHasSubmenu = /**
         * @param {?} hasSubmenu
         * @return {?}
         */
        function (hasSubmenu) {
            this.hasSubmenuSubject.next(hasSubmenu);
        };
        ItemService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ItemService.ctorParameters = function () { return []; };
        return ItemService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ItemService.prototype.hasSubmenuSubject;
        /** @type {?} */
        ItemService.prototype.hasSubmenu$;
        /**
         * @type {?}
         * @private
         */
        ItemService.prototype.hasWidthSubject;
        /** @type {?} */
        ItemService.prototype.width$;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/controls/context-menu-item.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ContextMenuItemComponent = /** @class */ (function () {
        function ContextMenuItemComponent(itemService, hostEl) {
            this.itemService = itemService;
            this.hostEl = hostEl;
            this.activate = new core.EventEmitter();
            this.lastHoveredSubject = new rxjs.BehaviorSubject(false);
        }
        Object.defineProperty(ContextMenuItemComponent.prototype, "hasSubmenu", {
            get: /**
             * @return {?}
             */
            function () {
                return this.hasSubmenuField;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextMenuItemComponent.prototype, "lastHovered", {
            get: /**
             * @return {?}
             */
            function () {
                return this.lastHoveredField;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ContextMenuItemComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.lastHoveredSubscription = this.lastHoveredSubject.subscribe((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _this.onHoverChange(_); }));
            this.hasSubmenuSubscription = this.itemService.hasSubmenu$.subscribe((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _this.hasSubmenuField = _; }));
        };
        /**
         * @param {?} _
         * @return {?}
         */
        ContextMenuItemComponent.prototype.onHoverChange = /**
         * @param {?} _
         * @return {?}
         */
        function (_) {
            this.lastHoveredField = _;
            if (this.lastHoveredField) {
                this.itemService.setItemWidth(this.hostEl.nativeElement.offsetWidth);
            }
        };
        /**
         * @return {?}
         */
        ContextMenuItemComponent.prototype.onMouseEnter = /**
         * @return {?}
         */
        function () {
            this.lastHoveredSubject.next(true);
            this.canDeactivate = false;
            this.activate.emit(true);
        };
        /**
         * @return {?}
         */
        ContextMenuItemComponent.prototype.onMouseLeave = /**
         * @return {?}
         */
        function () {
            this.canDeactivate = true;
        };
        /**
         * @return {?}
         */
        ContextMenuItemComponent.prototype.setAsInActive = /**
         * @return {?}
         */
        function () {
            if (this.canDeactivate === false) {
                return;
            }
            this.lastHoveredSubject.next(false);
        };
        /**
         * @return {?}
         */
        ContextMenuItemComponent.prototype.hide = /**
         * @return {?}
         */
        function () {
            this.lastHoveredSubject.next(false);
        };
        /**
         * @return {?}
         */
        ContextMenuItemComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.lastHoveredSubject != null) {
                this.lastHoveredSubscription.unsubscribe();
            }
            if (this.hasSubmenuSubscription != null) {
                this.hasSubmenuSubscription.unsubscribe();
            }
        };
        ContextMenuItemComponent.decorators = [
            { type: core.Component, args: [{
                        // tslint:disable-next-line:component-selector
                        selector: '[lib-context-menu-item]',
                        template: "<ng-content></ng-content>"
                        // tslint:disable-next-line:no-host-metadata-property
                        ,
                        host: {
                            '[class.context-menu-item]': '1',
                            '[class.center]': '1',
                            '[class.context-menu-hover]': 'lastHovered',
                            '[class.context-menu-visible]': 'lastHovered',
                            '[class.context-menu-submenu]': 'hasSubmenu',
                        },
                        providers: [ItemService]
                    }] }
        ];
        /** @nocollapse */
        ContextMenuItemComponent.ctorParameters = function () { return [
            { type: ItemService },
            { type: core.ElementRef }
        ]; };
        ContextMenuItemComponent.propDecorators = {
            activate: [{ type: core.Output }],
            onMouseEnter: [{ type: core.HostListener, args: ['mouseenter',] }],
            onMouseLeave: [{ type: core.HostListener, args: ['mouseleave',] }]
        };
        return ContextMenuItemComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ContextMenuItemComponent.prototype.canDeactivate;
        /** @type {?} */
        ContextMenuItemComponent.prototype.activate;
        /** @type {?} */
        ContextMenuItemComponent.prototype.lastHoveredSubject;
        /**
         * @type {?}
         * @private
         */
        ContextMenuItemComponent.prototype.lastHoveredField;
        /**
         * @type {?}
         * @private
         */
        ContextMenuItemComponent.prototype.hasSubmenuField;
        /**
         * @type {?}
         * @private
         */
        ContextMenuItemComponent.prototype.lastHoveredSubscription;
        /**
         * @type {?}
         * @private
         */
        ContextMenuItemComponent.prototype.hasSubmenuSubscription;
        /**
         * @type {?}
         * @private
         */
        ContextMenuItemComponent.prototype.itemService;
        /**
         * @type {?}
         * @private
         */
        ContextMenuItemComponent.prototype.hostEl;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/controls/context-menu.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ContextMenuComponent = /** @class */ (function () {
        function ContextMenuComponent(element, renderer) {
            this.element = element;
            this.renderer = renderer;
            this.visible = false;
            this.visibleAnimate = false;
            this.subscriptions = [];
        }
        /**
         * @return {?}
         */
        ContextMenuComponent.prototype.ngAfterContentChecked = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.subscriptions.length > 0 || this.directMenus.length === 0) {
                return;
            }
            this.directMenus.toArray().map((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _this.subscriptions.push(_.activate.subscribe((/**
             * @return {?}
             */
            function () { return _this.clearInactive(); }))); }));
        };
        /**
         * @private
         * @return {?}
         */
        ContextMenuComponent.prototype.clearInactive = /**
         * @private
         * @return {?}
         */
        function () {
            this.directMenus.map((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _.setAsInActive(); }));
        };
        /**
         * @param {?} data
         * @param {?} event
         * @return {?}
         */
        ContextMenuComponent.prototype.setup = /**
         * @param {?} data
         * @param {?} event
         * @return {?}
         */
        function (data, event) {
            this.data = data;
            this.show(event.clientX, event.clientY);
            event.preventDefault();
            event.stopPropagation();
            return false;
        };
        /**
         * @param {?} x
         * @param {?} y
         * @return {?}
         */
        ContextMenuComponent.prototype.show = /**
         * @param {?} x
         * @param {?} y
         * @return {?}
         */
        function (x, y) {
            var _this = this;
            this.renderer.setStyle(this.element.nativeElement, 'left', x + "px");
            this.renderer.setStyle(this.element.nativeElement, 'top', y + "px");
            this.visible = true;
            setTimeout((/**
             * @return {?}
             */
            function () { return _this.visibleAnimate = true; }));
        };
        /**
         * @return {?}
         */
        ContextMenuComponent.prototype.hide = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.visibleAnimate = false;
            setTimeout((/**
             * @return {?}
             */
            function () { return _this.visible = false; }), 300);
            this.menus.map((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _.hide(); }));
        };
        /**
         * @return {?}
         */
        ContextMenuComponent.prototype.onClick = /**
         * @return {?}
         */
        function () {
            this.hide();
        };
        /**
         * @param {?} ev
         * @return {?}
         */
        ContextMenuComponent.prototype.onContextMenu = /**
         * @param {?} ev
         * @return {?}
         */
        function (ev) {
            ev.preventDefault();
            ev.stopPropagation();
            return false;
        };
        /**
         * @return {?}
         */
        ContextMenuComponent.prototype.onScroll = /**
         * @return {?}
         */
        function () {
            this.hide();
        };
        /**
         * @return {?}
         */
        ContextMenuComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.subscriptions.map((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _.unsubscribe(); }));
        };
        ContextMenuComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-context-menu',
                        template: "\n      <nav class=\"context-menu\" tabindex=\"-1\" [ngClass]=\"{'in': visibleAnimate}\"\n      [ngStyle]=\"{'opacity': visibleAnimate ? 1 : 0, 'background-color':'white'}\">\n        <ul class=\"context-menu-list context-menu-root\">\n          <ng-content></ng-content>\n        </ul>\n      </nav>\n  ",
                        // tslint:disable-next-line:no-host-metadata-property
                        host: {
                            '[class.contextmenu-container]': '1',
                            '[class.show]': 'visible',
                            '[class.hide]': '!visible',
                        },
                        styles: ["@charset \"UTF-8\";:host ::ng-deep .context-menu-icon-add:before{content:\"\uEA01\"}:host ::ng-deep .context-menu-icon-copy:before{content:\"\uEA02\"}:host ::ng-deep .context-menu-icon-cut:before{content:\"\uEA03\"}:host ::ng-deep .context-menu-icon-delete:before{content:\"\uEA04\"}:host ::ng-deep .context-menu-icon-edit:before{content:\"\uEA05\"}:host ::ng-deep .context-menu-icon-paste:before{content:\"\uEA06\"}:host ::ng-deep .context-menu-icon-quit:before{content:\"\uEA07\"}:host ::ng-deep .context-menu-icon::before{position:absolute;top:50%;left:0;width:2em;font-family:context-menu-icons;font-size:1em;font-style:normal;font-weight:400;line-height:1;color:#2980b9;text-align:center;transform:translateY(-50%);-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}:host ::ng-deep .context-menu-icon.context-menu-hover:before{color:#fff}:host ::ng-deep .context-menu-icon.context-menu-disabled::before{color:#bbb}:host ::ng-deep .context-menu-icon.context-menu-icon--fa{display:list-item}:host ::ng-deep .context-menu-icon.context-menu-icon--fa::before{position:absolute;top:50%;left:0;width:2em;font-family:FontAwesome;font-size:1em;font-style:normal;font-weight:400;line-height:1;color:#2980b9;text-align:center;transform:translateY(-50%);-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}:host ::ng-deep .context-menu-icon.context-menu-icon--fa.context-menu-hover:before{color:#fff}:host ::ng-deep .context-menu-icon.context-menu-icon--fa.context-menu-disabled::before{color:#bbb}:host ::ng-deep .context-menu-list{position:absolute;display:inline-block;min-width:13em;max-width:26em;padding:.25em 0;margin:.03em;font-family:inherit;font-size:inherit;list-style-type:none;background:#fff;border:1px solid #bebebe;border-radius:.2em;box-shadow:0 2px 5px rgba(0,0,0,.5)}:host ::ng-deep .context-menu-item{position:relative;padding:.2em 2em;color:#2f2f2f;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;background-color:#fff}:host ::ng-deep .context-menu-separator{padding:0;margin:.35em 0;border-bottom:1px solid #e6e6e6}:host ::ng-deep .context-menu-item>label>input,:host ::ng-deep .context-menu-item>label>textarea{-webkit-user-select:text;-moz-user-select:text;-ms-user-select:text;user-select:text}:host ::ng-deep .context-menu-item.context-menu-hover{color:#fff;cursor:pointer;background-color:#2980b9}:host ::ng-deep .context-menu-item.context-menu-disabled{color:#bbb;cursor:default;background-color:#fff}:host ::ng-deep .context-menu-input.context-menu-hover{cursor:default}:host ::ng-deep .context-menu-submenu:after{position:absolute;top:50%;right:.5em;z-index:1001;width:0;height:0;content:\"\";border-color:transparent transparent transparent #2f2f2f;border-style:solid;border-width:.25em 0 .25em .25em;transform:translateY(-50%)}:host ::ng-deep .context-menu-item.context-menu-input{padding:.3em .6em}:host ::ng-deep .context-menu-input>label>*{vertical-align:top}:host ::ng-deep .context-menu-input>label>input[type=checkbox],:host ::ng-deep .context-menu-input>label>input[type=radio]{position:relative;top:.12em;margin-right:.4em}:host ::ng-deep .context-menu-input>label{margin:0}:host ::ng-deep .context-menu-input>label,:host ::ng-deep .context-menu-input>label>input[type=text],:host ::ng-deep .context-menu-input>label>select,:host ::ng-deep .context-menu-input>label>textarea{display:block;width:100%;box-sizing:border-box}:host ::ng-deep .context-menu-input>label>textarea{height:7em}:host ::ng-deep .context-menu-item>.context-menu-list{top:.3em;right:-.3em;display:none}:host ::ng-deep .context-menu-item.context-menu-visible>.context-menu-list{display:block}:host ::ng-deep .context-menu-accesskey{text-decoration:underline}", ":host(.hide) {\n      display: none;\n    }\n    :host(.contextmenu-container) {\n      position: fixed;\n      z-index: 1000;\n    }\n    :host(.show) {\n      display: block;\n    }\n  }"]
                    }] }
        ];
        /** @nocollapse */
        ContextMenuComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        ContextMenuComponent.propDecorators = {
            menus: [{ type: core.ContentChildren, args: [ContextMenuItemComponent, { descendants: true },] }],
            directMenus: [{ type: core.ContentChildren, args: [ContextMenuItemComponent, { descendants: false },] }],
            onClick: [{ type: core.HostListener, args: ['document:click', [],] }],
            onContextMenu: [{ type: core.HostListener, args: ['contextmenu', ['$event.target'],] }],
            onScroll: [{ type: core.HostListener, args: ['document:scroll', [],] }]
        };
        return ContextMenuComponent;
    }());
    if (false) {
        /** @type {?} */
        ContextMenuComponent.prototype.visible;
        /** @type {?} */
        ContextMenuComponent.prototype.visibleAnimate;
        /** @type {?} */
        ContextMenuComponent.prototype.data;
        /**
         * @type {?}
         * @private
         */
        ContextMenuComponent.prototype.subscriptions;
        /**
         * @type {?}
         * @private
         */
        ContextMenuComponent.prototype.menus;
        /**
         * @type {?}
         * @private
         */
        ContextMenuComponent.prototype.directMenus;
        /**
         * @type {?}
         * @private
         */
        ContextMenuComponent.prototype.element;
        /**
         * @type {?}
         * @private
         */
        ContextMenuComponent.prototype.renderer;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/controls/context-sub-menu.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ContextSubMenuComponent = /** @class */ (function () {
        function ContextSubMenuComponent(parentItem, hostEl, renderer) {
            this.parentItem = parentItem;
            this.hostEl = hostEl;
            this.renderer = renderer;
            this.childSubscriptions = [];
        }
        /**
         * @return {?}
         */
        ContextSubMenuComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.widthSubscription = this.parentItem.width$.subscribe((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _this.setPosition(_); }));
            this.parentItem.setHasSubmenu(true);
        };
        /**
         * @param {?} _
         * @return {?}
         */
        ContextSubMenuComponent.prototype.setPosition = /**
         * @param {?} _
         * @return {?}
         */
        function (_) {
            this.renderer.setStyle(this.hostEl.nativeElement, 'top', '0px');
            this.renderer.setStyle(this.hostEl.nativeElement, 'left', _ - 1 + "px");
            this.renderer.removeStyle(this.hostEl.nativeElement, 'right');
        };
        /**
         * @return {?}
         */
        ContextSubMenuComponent.prototype.ngAfterContentChecked = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.childSubscriptions.length > 0 || this.directMenus.length === 0) {
                return;
            }
            this.directMenus.toArray().map((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _this.childSubscriptions.push(_.activate.subscribe((/**
             * @return {?}
             */
            function () { return _this.clearInactive(); }))); }));
        };
        /**
         * @private
         * @return {?}
         */
        ContextSubMenuComponent.prototype.clearInactive = /**
         * @private
         * @return {?}
         */
        function () {
            this.directMenus.map((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _.setAsInActive(); }));
        };
        /**
         * @return {?}
         */
        ContextSubMenuComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.childSubscriptions.map((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _.unsubscribe(); }));
            this.widthSubscription.unsubscribe();
        };
        ContextSubMenuComponent.decorators = [
            { type: core.Component, args: [{
                        // tslint:disable-next-line:component-selector
                        selector: '[lib-context-submenu]',
                        template: "<ng-content></ng-content>",
                        // tslint:disable-next-line:no-host-metadata-property
                        host: {
                            '[class.context-menu-list]': '1',
                        }
                    }] }
        ];
        /** @nocollapse */
        ContextSubMenuComponent.ctorParameters = function () { return [
            { type: ItemService },
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        ContextSubMenuComponent.propDecorators = {
            directMenus: [{ type: core.ContentChildren, args: [ContextMenuItemComponent, { descendants: false },] }]
        };
        return ContextSubMenuComponent;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ContextSubMenuComponent.prototype.directMenus;
        /**
         * @type {?}
         * @private
         */
        ContextSubMenuComponent.prototype.childSubscriptions;
        /**
         * @type {?}
         * @private
         */
        ContextSubMenuComponent.prototype.widthSubscription;
        /**
         * @type {?}
         * @private
         */
        ContextSubMenuComponent.prototype.parentItem;
        /**
         * @type {?}
         * @private
         */
        ContextSubMenuComponent.prototype.hostEl;
        /**
         * @type {?}
         * @private
         */
        ContextSubMenuComponent.prototype.renderer;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/controls/context-menu-separator.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ContextMenuSeparatorComponent = /** @class */ (function () {
        function ContextMenuSeparatorComponent() {
        }
        ContextMenuSeparatorComponent.decorators = [
            { type: core.Component, args: [{
                        // tslint:disable-next-line:component-selector
                        selector: '[lib-context-menu-separator]',
                        template: "<li class=\"context-menu-separator\"></li>"
                    }] }
        ];
        return ContextMenuSeparatorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ContextMenuModule = /** @class */ (function () {
        function ContextMenuModule() {
        }
        /**
         * @return {?}
         */
        ContextMenuModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: ContextMenuModule,
                providers: []
            };
        };
        ContextMenuModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [
                            ContextMenuComponent, ContextMenuItemComponent, ContextSubMenuComponent, ContextMenuSeparatorComponent,
                        ],
                        exports: [
                            ContextMenuComponent, ContextMenuItemComponent, ContextSubMenuComponent, ContextMenuSeparatorComponent,
                        ],
                    },] }
        ];
        return ContextMenuModule;
    }());

    exports.ContextMenuComponent = ContextMenuComponent;
    exports.ContextMenuModule = ContextMenuModule;
    exports.ɵa = ContextMenuItemComponent;
    exports.ɵb = ItemService;
    exports.ɵc = ContextSubMenuComponent;
    exports.ɵd = ContextMenuSeparatorComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=controls-context-menu.umd.js.map
